SoTransform Class Reference
Node Classes

The SoTransform class is the "all-purpose" transformation node type. More...

`#include <Inventor/nodes/SoTransform.h>`

Inheritance diagram for SoTransform:

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoTransform (void)
void | pointAt (const SbVec3f &frompoint, const SbVec3f &topoint)
void | getScaleSpaceMatrix (SbMatrix &mat, SbMatrix &inv) const
void | getRotationSpaceMatrix (SbMatrix &mat, SbMatrix &inv) const
void | getTranslationSpaceMatrix (SbMatrix &mat, SbMatrix &inv) const
void | multLeft (const SbMatrix &mat)
void | multRight (const SbMatrix &mat)
void | combineLeft (SoTransformation *nodeonright)
void | combineRight (SoTransformation *nodeonleft)
void | setMatrix (const SbMatrix &mat)
void | recenter (const SbVec3f &newcenter)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoTransformation
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFVec3f | translation
SoSFRotation | rotation
SoSFVec3f | scaleFactor
SoSFRotation | scaleOrientation
SoSFVec3f | center

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoTransform ()
Protected Member Functions inherited from SoTransformation
| SoTransformation (void)
virtual | ~SoTransformation ()
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoTransformation
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members

Public Types inherited from SoNode

enum

NodeType {
INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 ,
INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 ,
COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 ,
COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 ,
COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000
}

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoTransform class is the "all-purpose" transformation node type.

Like SoMatrixTransform, nodes of this type give the application programmer maximum flexibility when specifying geometry transformations in a scene graph. If you want to set and keep the various components of the transformation matrix in separate entities, this node type is preferable, though.

The order of operations is: first scaling is done, then rotation, then translation.

FILE FORMAT/DEFAULTS:

Transform {
translation 0 0 0
rotation 0 0 1 0
scaleFactor 1 1 1
scaleOrientation 0 0 1 0
center 0 0 0
}
SoTransform::center
SoSFVec3f center
Definition SoTransform.h:56
SoTransform::rotation
SoSFRotation rotation
Definition SoTransform.h:53
SoTransform::scaleOrientation
SoSFRotation scaleOrientation
Definition SoTransform.h:55
SoTransform::scaleFactor
SoSFVec3f scaleFactor
Definition SoTransform.h:54
SoTransform::translation
SoSFVec3f translation
Definition SoTransform.h:52

## Constructor & Destructor Documentation

## SoTransform()

SoTransform::SoTransform | ( | void |  | ) |

Constructor.

## ~SoTransform()

SoTransform::~SoTransform | ( |  | ) |

protected virtual

Destructor.

## Member Function Documentation

## getClassTypeId()

SoType SoTransform::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getTypeId()

SoType SoTransform::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoTransformation.

Reimplemented in SoCenterballManip, SoHandleBoxManip, SoJackManip, SoTabBoxManip, SoTrackballManip, SoTransformBoxManip, SoTransformerManip, and SoTransformManip.

## getFieldDataPtr()

const SoFieldData ** SoTransform::getFieldDataPtr | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## getFieldData()

const SoFieldData * SoTransform::getFieldData | ( | void |  | ) | const

protected virtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoTransformation.

Reimplemented in SoCenterballManip, SoHandleBoxManip, SoJackManip, SoTabBoxManip, SoTrackballManip, SoTransformBoxManip, SoTransformerManip, and SoTransformManip.

## pointAt()

void SoTransform::pointAt | ( | const SbVec3f & | frompoint,
|  | const SbVec3f & | topoint )

Sets the transformation to translate to frompoint, with a rotation so that the (0,0,-1) vector is rotated into the vector from frompoint to topoint.

## getScaleSpaceMatrix()

void SoTransform::getScaleSpaceMatrix | ( | SbMatrix & | mat,
|  | SbMatrix & | inv ) const

Calculates the matrices to/from scale space.

## getRotationSpaceMatrix()

void SoTransform::getRotationSpaceMatrix | ( | SbMatrix & | mat,
|  | SbMatrix & | inv ) const

Calculates the matrices to/from rotation space.

## getTranslationSpaceMatrix()

void SoTransform::getTranslationSpaceMatrix | ( | SbMatrix & | mat,
|  | SbMatrix & | inv ) const

Calculates the matrices to/from translation space.

## multLeft()

void SoTransform::multLeft | ( | const SbMatrix & | mat | ) |

Premultiplies this transformation by mat.

## multRight()

void SoTransform::multRight | ( | const SbMatrix & | mat | ) |

Postmultiplies this transformation by mat.

## combineLeft()

void SoTransform::combineLeft | ( | SoTransformation * | nodeonright | ) |

Premultiplies this transformation by the transformation in nodeonright.

## combineRight()

void SoTransform::combineRight | ( | SoTransformation * | nodeonleft | ) |

Postmultiplies this transformation by the transformation in nodeonleft.

## setMatrix()

void SoTransform::setMatrix | ( | const SbMatrix & | mat | ) |

Sets the fields to create a transformation equal to mat.

## recenter()

void SoTransform::recenter | ( | const SbVec3f & | newcenter | ) |

Sets the center field to newcenter. This might affect one or more of the other fields.

## doAction()

void SoTransform::doAction | ( | SoAction * | action | ) |

virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

Reimplemented in SoTransformManip.

## GLRender()

void SoTransform::GLRender | ( | SoGLRenderAction * | action | ) |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

Reimplemented in SoTransformManip.

## callback()

void SoTransform::callback | ( | SoCallbackAction * | action | ) |

virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

Reimplemented in SoTransformManip.

## getBoundingBox()

void SoTransform::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) |

virtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoNode.

Reimplemented in SoTransformManip.

## getMatrix()

void SoTransform::getMatrix | ( | SoGetMatrixAction * | action | ) |

virtual

Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoNode.

Reimplemented in SoTransformManip.

## pick()

void SoTransform::pick | ( | SoPickAction * | action | ) |

virtual

Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

Reimplemented in SoTransformManip.

## getPrimitiveCount()

void SoTransform::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |

virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoNode.

## Member Data Documentation

## translation

SoSFVec3f SoTransform::translation

The translation part of the transformation.

## rotation

SoSFRotation SoTransform::rotation

The rotation part of the transformation.

Note that there is one very common mistake that is easy to make when setting the value of a an SoSFRotation field, and that is to inadvertently use the wrong SbRotation constructor. This example should clarify the problem:

mytransformnode->rotation.setValue(0, 0, 1, 1.5707963f);

The programmer clearly tries to set a PI/2 rotation around the Z-axis, but this will fail, as the SbRotation constructor invoked above is the one that takes as arguments the 4 floats of a quaternion. What the programmer almost certainly wanted to do was to use the SbRotation constructor that takes a rotation vector and a rotation angle, which is invoked like this:

mytransformnode->rotation.setValue(SbVec3f(0, 0, 1), 1.5707963f);
SbVec3f
The SbVec3f class is a 3 dimensional vector with floating point coordinates.
Definition SbVec3f.h:51

## scaleFactor

SoSFVec3f SoTransform::scaleFactor

The scaling part of the transformation.

## scaleOrientation

SoSFRotation SoTransform::scaleOrientation

The orientation the object is set to before scaling.

## center

SoSFVec3f SoTransform::center

The center point for the rotation.

The documentation for this class was generated from the following files:

- SoTransform.h
- SoTransform.cpp